/**
 *
 * Please note:
 * This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * Do not edit this file manually.
 *
 */

@file:Suppress(
    "ArrayInDataClass",
    "EnumEntryName",
    "RemoveRedundantQualifierName",
    "UnusedImport"
)

package tech.carpentum.sdk.payment.internal.generated.api

import java.io.IOException
import okhttp3.OkHttpClient
import okhttp3.HttpUrl

import tech.carpentum.sdk.payment.model.AvailableForexCurrencyPairList
import tech.carpentum.sdk.payment.model.BasicError
import tech.carpentum.sdk.payment.model.ForexRateList
import tech.carpentum.sdk.payment.model.GetFxRatesError

import com.squareup.moshi.Json

import tech.carpentum.sdk.payment.internal.generated.infrastructure.ApiClient
import tech.carpentum.sdk.payment.internal.generated.infrastructure.ApiResponse
import tech.carpentum.sdk.payment.internal.generated.infrastructure.ClientException
import tech.carpentum.sdk.payment.internal.generated.infrastructure.ClientError
import tech.carpentum.sdk.payment.internal.generated.infrastructure.ServerException
import tech.carpentum.sdk.payment.internal.generated.infrastructure.ServerError
import tech.carpentum.sdk.payment.internal.generated.infrastructure.MultiValueMap
import tech.carpentum.sdk.payment.internal.generated.infrastructure.PartConfig
import tech.carpentum.sdk.payment.internal.generated.infrastructure.RequestConfig
import tech.carpentum.sdk.payment.internal.generated.infrastructure.RequestMethod
import tech.carpentum.sdk.payment.internal.generated.infrastructure.ResponseType
import tech.carpentum.sdk.payment.internal.generated.infrastructure.Success
import tech.carpentum.sdk.payment.internal.generated.infrastructure.toMultiValue

internal open class RateListsApi(basePath: kotlin.String = defaultBasePath, client: OkHttpClient = ApiClient.defaultClient) : ApiClient(basePath, client) {
    companion object {
        @JvmStatic
        val defaultBasePath: String by lazy {
            System.getProperties().getProperty(ApiClient.baseUrlKey, "https://api.sandbox.carpentum.tech")
        }
    }

    /**
     * List of currency pairs.
     * Method returns a list of currency pairs for which our system usually contains valid FX rates.
     * @param xAPIVersion Required API version. See [Versioning](general.html#versioning)
     * @param tenantCode 
     * @param merchantCode 
     * @return AvailableForexCurrencyPairList
     * @throws IllegalStateException If the request is not correctly configured
     * @throws IOException Rethrows the OkHttp execute method exception
     * @throws UnsupportedOperationException If the API returns an informational or redirection response
     * @throws ClientException If the API returns a client error response
     * @throws ServerException If the API returns a server error response
     */
    @Suppress("UNCHECKED_CAST")
    @Throws(IllegalStateException::class, IOException::class, UnsupportedOperationException::class, ClientException::class, ServerException::class)
    fun getFxRatePairs(xAPIVersion: kotlin.Int, tenantCode: kotlin.String, merchantCode: kotlin.String) : AvailableForexCurrencyPairList {
        val localVarResponse = getFxRatePairsWithHttpInfo(xAPIVersion = xAPIVersion, tenantCode = tenantCode, merchantCode = merchantCode)

        return when (localVarResponse.responseType) {
            ResponseType.Success -> (localVarResponse as Success<*>).data as AvailableForexCurrencyPairList
            ResponseType.Informational -> throw UnsupportedOperationException("Client does not support Informational responses.")
            ResponseType.Redirection -> throw UnsupportedOperationException("Client does not support Redirection responses.")
            ResponseType.ClientError -> {
                val localVarError = localVarResponse as ClientError<*>
                throw ClientException("Client error : ${localVarError.statusCode} ${localVarError.message.orEmpty()}", localVarError.statusCode, localVarResponse)
            }
            ResponseType.ServerError -> {
                val localVarError = localVarResponse as ServerError<*>
                throw ServerException("Server error : ${localVarError.statusCode} ${localVarError.message.orEmpty()} ${localVarError.body}", localVarError.statusCode, localVarResponse)
            }
        }
    }

    /**
     * List of currency pairs.
     * Method returns a list of currency pairs for which our system usually contains valid FX rates.
     * @param xAPIVersion Required API version. See [Versioning](general.html#versioning)
     * @param tenantCode 
     * @param merchantCode 
     * @return ApiResponse<AvailableForexCurrencyPairList?>
     * @throws IllegalStateException If the request is not correctly configured
     * @throws IOException Rethrows the OkHttp execute method exception
     */
    @Suppress("UNCHECKED_CAST")
    @Throws(IllegalStateException::class, IOException::class)
    fun getFxRatePairsWithHttpInfo(xAPIVersion: kotlin.Int, tenantCode: kotlin.String, merchantCode: kotlin.String) : ApiResponse<AvailableForexCurrencyPairList?> {
        val localVariableConfig = getFxRatePairsRequestConfig(xAPIVersion = xAPIVersion, tenantCode = tenantCode, merchantCode = merchantCode)

        return request<Unit, AvailableForexCurrencyPairList>(
            localVariableConfig
        )
    }

    /**
     * To obtain the request config of the operation getFxRatePairs
     *
     * @param xAPIVersion Required API version. See [Versioning](general.html#versioning)
     * @param tenantCode 
     * @param merchantCode 
     * @return RequestConfig
     */
    fun getFxRatePairsRequestConfig(xAPIVersion: kotlin.Int, tenantCode: kotlin.String, merchantCode: kotlin.String) : RequestConfig<Unit> {
        val localVariableBody = null
        val localVariableQuery: MultiValueMap = mutableMapOf()
        val localVariableHeaders: MutableMap<String, String> = mutableMapOf()
        xAPIVersion.apply { localVariableHeaders["X-API-Version"] = this.toString() }
        tenantCode.apply { localVariableHeaders["Tenant-Code"] = this.toString() }
        merchantCode.apply { localVariableHeaders["Merchant-Code"] = this.toString() }
        localVariableHeaders["Accept"] = "application/json"

        return RequestConfig(
            method = RequestMethod.GET,
            path = "/fx-rate-pairs",
            query = localVariableQuery,
            headers = localVariableHeaders,
            requiresAuthentication = false,
            body = localVariableBody
        )
    }

    /**
     * List of valid FX rates.
     * Method returns a list of currently valid FX rates.
     * @param xAPIVersion Required API version. See [Versioning](general.html#versioning)
     * @param tenantCode 
     * @param merchantCode 
     * @param baseCurrencyCode Specific base currency code for which valid FX rates should be returned. Fiat currency codes are based on 3-letter ISO 4217. Crypto currency codes are based on commonly used codes. (optional)
     * @param quoteCurrencyCode Specific quote currency code for which valid FX rates should be returned. Fiat currency codes are based on 3-letter ISO 4217. Crypto currency codes are based on commonly used codes. (optional)
     * @return ForexRateList
     * @throws IllegalStateException If the request is not correctly configured
     * @throws IOException Rethrows the OkHttp execute method exception
     * @throws UnsupportedOperationException If the API returns an informational or redirection response
     * @throws ClientException If the API returns a client error response
     * @throws ServerException If the API returns a server error response
     */
    @Suppress("UNCHECKED_CAST")
    @Throws(IllegalStateException::class, IOException::class, UnsupportedOperationException::class, ClientException::class, ServerException::class)
    fun getFxRates(xAPIVersion: kotlin.Int, tenantCode: kotlin.String, merchantCode: kotlin.String, baseCurrencyCode: kotlin.String? = null, quoteCurrencyCode: kotlin.String? = null) : ForexRateList {
        val localVarResponse = getFxRatesWithHttpInfo(xAPIVersion = xAPIVersion, tenantCode = tenantCode, merchantCode = merchantCode, baseCurrencyCode = baseCurrencyCode, quoteCurrencyCode = quoteCurrencyCode)

        return when (localVarResponse.responseType) {
            ResponseType.Success -> (localVarResponse as Success<*>).data as ForexRateList
            ResponseType.Informational -> throw UnsupportedOperationException("Client does not support Informational responses.")
            ResponseType.Redirection -> throw UnsupportedOperationException("Client does not support Redirection responses.")
            ResponseType.ClientError -> {
                val localVarError = localVarResponse as ClientError<*>
                throw ClientException("Client error : ${localVarError.statusCode} ${localVarError.message.orEmpty()}", localVarError.statusCode, localVarResponse)
            }
            ResponseType.ServerError -> {
                val localVarError = localVarResponse as ServerError<*>
                throw ServerException("Server error : ${localVarError.statusCode} ${localVarError.message.orEmpty()} ${localVarError.body}", localVarError.statusCode, localVarResponse)
            }
        }
    }

    /**
     * List of valid FX rates.
     * Method returns a list of currently valid FX rates.
     * @param xAPIVersion Required API version. See [Versioning](general.html#versioning)
     * @param tenantCode 
     * @param merchantCode 
     * @param baseCurrencyCode Specific base currency code for which valid FX rates should be returned. Fiat currency codes are based on 3-letter ISO 4217. Crypto currency codes are based on commonly used codes. (optional)
     * @param quoteCurrencyCode Specific quote currency code for which valid FX rates should be returned. Fiat currency codes are based on 3-letter ISO 4217. Crypto currency codes are based on commonly used codes. (optional)
     * @return ApiResponse<ForexRateList?>
     * @throws IllegalStateException If the request is not correctly configured
     * @throws IOException Rethrows the OkHttp execute method exception
     */
    @Suppress("UNCHECKED_CAST")
    @Throws(IllegalStateException::class, IOException::class)
    fun getFxRatesWithHttpInfo(xAPIVersion: kotlin.Int, tenantCode: kotlin.String, merchantCode: kotlin.String, baseCurrencyCode: kotlin.String?, quoteCurrencyCode: kotlin.String?) : ApiResponse<ForexRateList?> {
        val localVariableConfig = getFxRatesRequestConfig(xAPIVersion = xAPIVersion, tenantCode = tenantCode, merchantCode = merchantCode, baseCurrencyCode = baseCurrencyCode, quoteCurrencyCode = quoteCurrencyCode)

        return request<Unit, ForexRateList>(
            localVariableConfig
        )
    }

    /**
     * To obtain the request config of the operation getFxRates
     *
     * @param xAPIVersion Required API version. See [Versioning](general.html#versioning)
     * @param tenantCode 
     * @param merchantCode 
     * @param baseCurrencyCode Specific base currency code for which valid FX rates should be returned. Fiat currency codes are based on 3-letter ISO 4217. Crypto currency codes are based on commonly used codes. (optional)
     * @param quoteCurrencyCode Specific quote currency code for which valid FX rates should be returned. Fiat currency codes are based on 3-letter ISO 4217. Crypto currency codes are based on commonly used codes. (optional)
     * @return RequestConfig
     */
    fun getFxRatesRequestConfig(xAPIVersion: kotlin.Int, tenantCode: kotlin.String, merchantCode: kotlin.String, baseCurrencyCode: kotlin.String?, quoteCurrencyCode: kotlin.String?) : RequestConfig<Unit> {
        val localVariableBody = null
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>()
            .apply {
                if (baseCurrencyCode != null) {
                    put("baseCurrencyCode", listOf(baseCurrencyCode.toString()))
                }
                if (quoteCurrencyCode != null) {
                    put("quoteCurrencyCode", listOf(quoteCurrencyCode.toString()))
                }
            }
        val localVariableHeaders: MutableMap<String, String> = mutableMapOf()
        xAPIVersion.apply { localVariableHeaders["X-API-Version"] = this.toString() }
        tenantCode.apply { localVariableHeaders["Tenant-Code"] = this.toString() }
        merchantCode.apply { localVariableHeaders["Merchant-Code"] = this.toString() }
        localVariableHeaders["Accept"] = "application/json"

        return RequestConfig(
            method = RequestMethod.GET,
            path = "/fx-rates",
            query = localVariableQuery,
            headers = localVariableHeaders,
            requiresAuthentication = false,
            body = localVariableBody
        )
    }


    private fun encodeURIComponent(uriComponent: kotlin.String): kotlin.String =
        HttpUrl.Builder().scheme("http").host("localhost").addPathSegment(uriComponent).build().encodedPathSegments[0]
}
